码迷,mamicode.com
首页 > 其他好文 > 详细

HDU 4283 You are the one(区间DP)

时间:2015-03-13 18:53:50      阅读:132      评论:0      收藏:0      [点我收藏+]

标签:acm   dp   

题目大意:

  The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?


解题思路:

区间DP,dp[i][j]表示从i到j的沮丧值,枚举第i个人的出场顺序。


#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <string>
#include <vector>
#include <queue>
#include <stack>
#include <set>
#include <map>
#define LL long long 
using namespace std;
const int MAXN = 100 + 10;
const int inf = 0x3f3f3f3f;
int dp[MAXN][MAXN];
int a[MAXN], sum[MAXN];
int N;
int main()
{
	int T, kcase = 1;
	scanf("%d", &T);
	while(T--)
	{
		scanf("%d", &N);
		memset(sum, 0, sizeof(sum));
		memset(dp, 0, sizeof(dp));
		for(int i=1;i<=N;i++)
		{
			scanf("%d", &a[i]);
			sum[i] = sum[i-1] + a[i];
		}
		memset(dp, 0, sizeof(dp));
		for(int i=1;i<=N;i++)
		{
			for(int j=i+1;j<=N;j++)
				dp[i][j] = inf;
		}
		for(int len=1;len<N;len++)
		{
			for(int i=1;i+len<=N;i++)
			{
				int j = i + len;
				for(int k=1;k<=j-i+1;k++)//第i个人第K个上场
				{
					dp[i][j] = min(dp[i][j], dp[i+1][i+k-1] + a[i] * (k-1) + dp[i+k][j] + k * (sum[j] - sum[i+k-1]));
					/*dp[i+1][i+k-1]表示前k-1个人的沮丧值,a[i] * (k-1)表示第i个人的沮丧值,而i+k到j的这些人由于出场位置都增加了K,所以总的沮丧值增加了k * (sum[j] - sum[i+k-1]);*/
				}
			}
		}
		printf("Case #%d: %d\n", kcase++, dp[1][N]);
	}
	return 0;
}


HDU 4283 You are the one(区间DP)

标签:acm   dp   

原文地址:http://blog.csdn.net/moguxiaozhe/article/details/44243297

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!